<?php

// load Tonic library
require_once __DIR__.'/../library/tonic/lib/tonic.php';

// load Expresso classes
require_once("./core/Errors.php");
require_once("./core/Expresso.php");

// Load all resources
require_once("./core/ExpressoVersionResource.php");
require_once("./core/LoginResource.php");
require_once("./core/LogoutResource.php");

require_once("./mail/Mail.php");
require_once("./mail/FoldersResource.php");
require_once("./mail/MessagesResource.php");
require_once("./mail/CleanTrashResource.php");
require_once("./mail/SendSupportFeedbackResource.php");

require_once("./catalog/Catalog.php");
require_once("./catalog/ContactsResource.php");
require_once("./catalog/ContactPictureResource.php");

//Retrieveing the mapping of the URIs and his respectives classNames and classPath
$config = parse_ini_file( __DIR__ . '/../config/Tonic.srv', true );
$autoload = array();
$classpath = array();

foreach( $config as $uri => $classFile )
	foreach( $classFile as $className => $filePath )
	{
		$autoload[ $uri ] = $className;
		$classpath[ $className ] = $filePath;
	}

	$request = new Request(array(
			'baseUri' => dirname($_SERVER['SCRIPT_NAME']),
			'autoload' => $autoload
	));
	
try {
	$resource = $request->loadResource();
	$response = $resource->exec($request);
	
} catch (ResponseException $e) {
	
	switch ($e->getCode()) {
		
		case Response::UNAUTHORIZED:
			$response = $e->response($request);
			$response->addHeader('WWW-Authenticate', 'Basic realm="Tonic"');
			break;
		default:
			$response = Errors::getResponse($request, $e);
	}
}

$response->output();

?>
